namespace TestProject;

/// <summary>
/// ׷
/// </summary>
public class Graph
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// ؽ ųʸ
    /// </summary>
    private Dictionary<string, Dictionary<string, int>> vertexDictionary = new Dictionary<string, Dictionary<string, int>>();

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  ߰ϱ - AddEdge(startNode, endNode, weight)

    /// <summary>
    ///  ߰ϱ
    /// </summary>
    /// <param name="startNode"> </param>
    /// <param name="endNode"> </param>
    /// <param name="weight">ġ</param>
    public void AddEdge(string startNode, string endNode, int weight)
    {
        if(!this.vertexDictionary.ContainsKey(startNode))
        {
            this.vertexDictionary[startNode] = new Dictionary<string, int>();
        }

        this.vertexDictionary[startNode][endNode] = weight;
    }

    #endregion
    #region ִ  Ʈ ϱ - GetShortestPathList(startNode, endNode)

    /// <summary>
    /// ִ  Ʈ ϱ
    /// </summary>
    /// <param name="startNode"> </param>
    /// <param name="endNode"> </param>
    /// <returns>ִ  Ʈ</returns>
    public List<string> GetShortestPathList(string startNode, string endNode)
    {
        Dictionary<string, int> distanceDictionary = new Dictionary<string, int>();

        Dictionary<string, string> previousNodeDictionary = new Dictionary<string, string>();

        List<string> nodeList = new List<string>();

        List<string> pathList = null;

        foreach(KeyValuePair<string, Dictionary<string, int>> keyValurPair in vertexDictionary)
        {
            if(keyValurPair.Key == startNode)
            {
                distanceDictionary[keyValurPair.Key] = 0;
            }
            else
            {
                distanceDictionary[keyValurPair.Key] = int.MaxValue;
            }

            nodeList.Add(keyValurPair.Key);
        }

        while(nodeList.Count != 0)
        {
            nodeList.Sort((x, y) => distanceDictionary[x].CompareTo(distanceDictionary[y]));

            string smallestNode = nodeList[0];

            nodeList.Remove(smallestNode);

            if(smallestNode == endNode)
            {
                pathList = new List<string>();

                while(previousNodeDictionary.ContainsKey(smallestNode))
                {
                    pathList.Add(smallestNode);

                    smallestNode = previousNodeDictionary[smallestNode];
                }

                pathList.Add(startNode);

                pathList.Reverse();
            }

            if(distanceDictionary[smallestNode] == int.MaxValue)
            {
                break;
            }

            if(vertexDictionary.ContainsKey(smallestNode))
            {
                foreach(KeyValuePair<string, int> neighbor in vertexDictionary[smallestNode])
                {
                    if (!distanceDictionary.ContainsKey(neighbor.Key))
                    {
                        distanceDictionary[neighbor.Key] = int.MaxValue;
                        nodeList.Add(neighbor.Key);
                    }

                    var alt = distanceDictionary[smallestNode] + neighbor.Value;
                    if (alt < distanceDictionary[neighbor.Key])
                    {
                        distanceDictionary[neighbor.Key] = alt;
                        previousNodeDictionary[neighbor.Key] = smallestNode;
                    }
                }
            }
        }

        return pathList;
    }

    #endregion
}